﻿Public Class Form1
    Dim Cls_File As New NSDFile
    Dim Cls_CopyFile As NSDFile.NSDCopyFile = Nothing
    Dim Cls_CopyFolder As NSDFile.NSDCopyFolder = Nothing
    Dim Cls_DeleteFolder As NSDFile.NSDDeleteFolder = Nothing
    Dim Cls_FolderSize As NSDFile.NSDFolderSize = Nothing
    Dim Cls_TextFile As NSDFile.NSDTextFile = New NSDFile.NSDTextFile

    Dim BlnCls_ListFileOrFolder As Boolean = True   ' リストの取得種類 True:ファイル False:フォルダー.
    Dim BlnCls_GetFileFolder As Boolean = False     ' ファイル、フォルダーリストの取得フラグ True:取得中 False:取得していません.
    Dim BlnCls_CopyFileOrFolder As Boolean = True   ' コピーの種類 True:ファイル False:フォルダー.
    Dim BlnCls_CopyFileFolder As Boolean = False    ' ファイル、フォルダーのコピーフラグ True:コピー中 False:コピーしていません.
    Dim BlnCls_DeleteFolder As Boolean = False      ' フォルダー削除フラグ True:削除中 False:削除していません.
    Dim BlnCls_FolderSize As Boolean = False        ' フォルダーサイズフラグ True:取得中 False:取得していません.
    Dim BlnCls_PathFileOrFolder As Boolean = True   ' パス True:ファイル False:フォルダー. 
    Dim BlnCls_OtherFileOrFolder As Boolean = True  ' その他 True:ファイル False:フォルダー.

    ' 表示用コントロールをセット.
    Dim Cls_CopyFileDispControl As New NSDFile.NSD_Asynchronization_DispControl     ' コピーファイル用.
    Dim Cls_FolderSizeDispControl As New NSDFile.NSD_Asynchronization_DispControl   ' フォルダーサイズ用.
    Dim Cls_CopyFolderDispControl As New NSDFile.NSD_Asynchronization_DispControl   ' コピーフォルダー用.

    ' フォルダー削除用変数.
    Dim IntCls_DeleteFolder_FileCount As Integer = 0    ' 削除ファイル数.
    Dim IntCls_DeleteFolder_FolderCount As Integer = 0  ' 削除フォルダー数.

    ' 参照ボタン
    Private Btn_Reference() As System.Windows.Forms.Button
    Delegate Sub SetName_Invoke(ByVal StrVal_Name As String)

    #Region "Class ClsEncodeInfo : エンコード情報用クラス."
        Public Class ClsEncodeInfo
            Dim Str_Name As String = Nothing            ' 名前.
            Dim Enc As System.Text.Encoding = Nothing   ' Text.Encoding.

            #Region "Sub New : リソースの割り当て."
                Sub New (ByVal ByVal_Name As String, ByVal ByVal_Enc As System.Text.Encoding)
                    Try
                        Str_Name = ByVal_Name
                        Enc = ByVal_Enc
                    Catch ex As Exception

                    End Try
                End Sub
            #End Region

            #Region "ReadOnly Property Encode : Text.Encoding."
                Public ReadOnly Property Encode() As System.Text.Encoding
                    Get
                        Return Enc
                    End Get
                End Property
            #End Region

            #Region "Overrides Function ToString : 名前を返します."
                Public Overrides Function ToString() As String
                    Return Str_Name.ToString()
                End Function
            #End Region
        End Class
    #End Region

    #Region "フォーム."
        #Region "Sub Form1_Load : Loadイベント."
            Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
                Try
                    ' 参照ボタンの設定.
                    SetReferenceButton(True)

                    ' コピーファイル用コントロールを設定.
                        ' プログレスバーをセット.
                        Cls_CopyFileDispControl.AddProgressBar(Me.PB_Copy)
                        ' コピーサイズ表示用ラベルをセット.
                        Cls_CopyFileDispControl.AddControl(Me.Lbl_CopySize, _
                                                           NSDFile.NSD_DispControl_Style.ChangeText, _
                                                           NSDFile.NSD_DispControl_TextStyle.CopyFile_SourceSizeAndCopySize + _
                                                           NSDFile.NSD_DispControl_TextStyle.Plus_Kanma + _
                                                           NSDFile.NSD_DispControl_TextStyle.Plus_UnitChange, _
                                                           "1ファイルのコピー状況", _
                                                           " [", _
                                                           "]")
                        ' コピー状況のパーセント表示用ラベルをセット.
                        Cls_CopyFileDispControl.AddControl(Me.Lbl_Parsent, _
                                                           NSDFile.NSD_DispControl_Style.ChangeText, _
                                                           NSDFile.NSD_DispControl_TextStyle.CopyFile_Parsent, _
                                                           "", _
                                                           "(", _
                                                           "%)")

                    ' コピーフォルダー用コントロールを設定.
                        ' ファイル用コントロールを設定.
                            ' プログレスバーをセット.
                            Cls_CopyFolderDispControl.AddProgressBar(Me.PB_Copy, _
                                                                     NSDFile.NSD_DispControl_ControlKind.SelectCopyFile)
                            ' コピーサイズ表示用ラベルをセット.
                            Cls_CopyFolderDispControl.AddControl(Me.Lbl_CopySize, _
                                                                 NSDFile.NSD_DispControl_Style.ChangeText, _
                                                                 NSDFile.NSD_DispControl_TextStyle.CopyFile_SourceSizeAndCopySize + _
                                                                 NSDFile.NSD_DispControl_TextStyle.Plus_Kanma + _
                                                                 NSDFile.NSD_DispControl_TextStyle.Plus_UnitChange, _
                                                                 "1ファイルのコピー状況", _
                                                                 " [", _
                                                                 "]", _
                                                                 NSDFile.NSD_DispControl_ControlKind.SelectCopyFile)
                            ' コピー状況のパーセント表示用ラベルをセット.
                            Cls_CopyFolderDispControl.AddControl(Me.Lbl_Parsent, _
                                                                 NSDFile.NSD_DispControl_Style.ChangeText, _
                                                                 NSDFile.NSD_DispControl_TextStyle.CopyFile_Parsent, _
                                                                 "", _
                                                                 "(", _
                                                                 "%)", _
                                                                 NSDFile.NSD_DispControl_ControlKind.SelectCopyFile)
                        ' フォルダー用コントロールを設定.
                            ' プログレスバーをセット.
                            Cls_CopyFolderDispControl.AddProgressBar(Me.PB_Folder, _
                                                                     NSDFile.NSD_DispControl_ControlKind.SelectCopyFolder)
                            ' コピーサイズ表示用ラベルをセット.
                            Cls_CopyFolderDispControl.AddControl(Me.Lbl_CopyFileCount, _
                                                                 NSDFile.NSD_DispControl_Style.ChangeText, _
                                                                 NSDFile.NSD_DispControl_TextStyle.CopyFolder_FileCountAndAllFileCount + _
                                                                 NSDFile.NSD_DispControl_TextStyle.Plus_Kanma, _
                                                                 "全体のコピー状況", _
                                                                 " [", _
                                                                 "]", _
                                                                 NSDFile.NSD_DispControl_ControlKind.SelectCopyFolder)
                            ' コピー状況のパーセント表示用ラベルをセット.
                            Cls_CopyFolderDispControl.AddControl(Me.Lbl_CopyFileCountParsent, _
                                                                 NSDFile.NSD_DispControl_Style.ChangeText, _
                                                                 NSDFile.NSD_DispControl_TextStyle.CopyFolder_Parsent, _
                                                                 "", _
                                                                 "(", _
                                                                 "%)", _
                                                                 NSDFile.NSD_DispControl_ControlKind.SelectCopyFolder)

                    ' フォルダーサイズ用コントロールを設定.
                        ' ファイル数+フォルダー数を設定.
                        Cls_FolderSizeDispControl.AddControl(Me.Lbl_FileCount, _
                                                             NSDFile.NSD_DispControl_Style.ChangeText, _
                                                             NSDFile.NSD_DispControl_TextStyle.FolderSize_FileCountAndFolderCount + _
                                                             NSDFile.NSD_DispControl_TextStyle.Plus_Kanma, _
                                                             "内容：", _
                                                             " ファイル数：", _
                                                             "、フォルダー数：")
                        ' フォルダーサイズを設定.
                        Cls_FolderSizeDispControl.AddControl(Me.Lbl_FolderSize, _
                                                             NSDFile.NSD_DispControl_Style.ChangeText, _
                                                             NSDFile.NSD_DispControl_TextStyle.FolderSize_FolderSize + _
                                                             NSDFile.NSD_DispControl_TextStyle.Plus_Kanma + _
                                                             NSDFile.NSD_DispControl_TextStyle.Plus_UnitChange, _
                                                             "フォルダーサイズ", _
                                                             "：", _
                                                             "")

                    ' エンコーディングのセット.
                        With Me.Cmb_TextFile
                            .Items.Clear
                            Dim Int_Index As Integer = -1
                            Dim Int_SelectIndex As Integer = -1

                            For Each EncInfo As System.Text.EncodingInfo In System.Text.Encoding.GetEncodings()
                                Dim SetEncInfo As System.Text.Encoding = EncInfo.GetEncoding
                                Dim Cls_Enc As New ClsEncodeInfo(SetEncInfo.EncodingName, SetEncInfo)
                                .Items.Add (Cls_Enc)
                                Int_Index += 1
                                If System.Text.Encoding.Default.CodePage = Cls_Enc.Encode.CodePage Then
                                    Int_SelectIndex = Int_Index
                                End If
                            Next
                            If Int_SelectIndex <> -1 Then
                                .SelectedIndex = Int_SelectIndex
                            End If
                        End With

                    ' 改行コードのセット.
                        With Me.Cmb_CrLf
                            .Items.Clear

                            .Items.Add("CrLf")
                            .Items.Add("Lf")
                            .Items.Add("Cr")
                            .SelectedIndex = 0
                        End With

                Catch ex As Exception
                End Try
            End Sub
        #End Region

        #Region "Sub Form1_FormClosing : FormClosing"
            Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
                Try
                    ' 参照ボタンの解除.
                    SetReferenceButton(False)

                    ' フォルダーサイズ用コントロールの解放処理.
                    If Not (Cls_FolderSizeDispControl Is Nothing) Then
                        Cls_FolderSizeDispControl.Dispose()
                        Cls_FolderSizeDispControl = Nothing
                    End If

                    ' コピーファイル用コントロールの解放処理.
                    If Not (Cls_CopyFileDispControl Is Nothing) Then
                        Cls_CopyFileDispControl.Dispose()
                        Cls_CopyFileDispControl= Nothing
                    End If

                    ' コピーフォルダー用コントロールの解放処理.
                    If Not (Cls_CopyFolderDispControl Is Nothing) Then
                        Cls_CopyFolderDispControl.Dispose()
                        Cls_CopyFolderDispControl = Nothing
                    End If

                    ' フォルダー削除の解放.                    
                    If Not (Cls_DeleteFolder Is Nothing) Then
                        Cls_DeleteFolder.Dispose()
                        Cls_DeleteFolder = Nothing
                    End If

                    ' フォルダーサイズの解放.
                    If Not (Cls_FolderSize Is Nothing) Then
                        Cls_FolderSize.Dispose()
                        Cls_FolderSize = Nothing
                    End If

                    ' フォルダーコピーの解放.
                    If Not (Cls_CopyFolder Is Nothing) Then
                        Cls_CopyFolder.Dispose()
                        Cls_CopyFolder = Nothing
                    End If

                    ' コピーファイルの解放.
                    If Not (Cls_CopyFile Is Nothing) Then
                        Cls_CopyFile.Dispose()
                        Cls_CopyFile = Nothing
                    End If

                    ' NSDFileの解放.
                    If Not (Cls_File Is Nothing) Then
                        Cls_File.Dispose()
                        Cls_File = Nothing
                    End If
                Catch ex As Exception
                End Try
            End Sub
        #End Region
    #End Region

    #Region "リストを取得します."
        #Region "Sub Btn_GetFile_Click : リストを取得します."
            Private Sub Btn_GetFile_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Btn_GetFile.Click
                Try
                    Select Case BlnCls_GetFileFolder
                        Case False
                            If IsRunOk(RunKind.GetFile) AndAlso IsRunOk(RunKind.GetFolder) Then
                                ' リストを取得します.
                                Me.ListBox1.Items.Clear
                                Me.Lbl_ListCount.Text = "取得件数：0"
                                Select Case BlnCls_ListFileOrFolder
                                    Case True
                                        ' ファイルリスト取得.
                                        BlnCls_GetFileFolder = Cls_File.GetFileList(Me.TextBox1.Text, _
                                                                                    Me.Txt_SearchPattern.Text, _
                                                                                    Me.Chk_List1.Checked, _
                                                                                    0, _
                                                                                    0, _
                                                                                    IO.FileAttributes.System , _
                                                                                    AddressOf GetFileListOneAdd_Callback, _
                                                                                    Nothing, _
                                                                                    AddressOf GetFileListEnd_Callback)
                                    Case Else
                                        ' フォルダーリスト取得.
                                        BlnCls_GetFileFolder = Cls_File.GetFolderList(Me.TextBox1.Text, _
                                                                                      Me.Chk_List1.Checked, _
                                                                                      0, _
                                                                                      0, _
                                                                                      True, _
                                                                                      AddressOf GetFileListOneAdd_Callback, _
                                                                                      AddressOf GetFileListEnd_Callback)
                                End Select
                                If BlnCls_GetFileFolder Then
                                    Me.Btn_GetFile.Text = "中止"
                                Else
                                    MsgBox("リストが取れません。")
                                End If
                            End If
                        Case True
                            ' リストの取得を中止します.
                            Me.Btn_GetFile.Text = "リストの取得"
                            Select Case BlnCls_ListFileOrFolder
                                Case True
                                    ' ファイルリスト取得の中止.
                                    Cls_File.StopGetFileList = True
                                Case Else
                                    ' フォルダーリスト取得の中止.
                                    Cls_File.StopGetFolderList = True
                            End Select
                            BlnCls_GetFileFolder = False
                    End Select
                Catch ex As Exception
                End Try
            End Sub
        #End Region

        #Region "Sub GetFileListOneAdd_Callback : ファイルまたはフォルダーを1件取得した時に呼び出されるイベント関数."
            Private Sub GetFileListOneAdd_Callback(ByVal sender As Object, ByVal e As NSDFile.NSDFileFolderListEventArgs)
                Try
                    With e.List
                        Dim Str_FullName As String = Nothing
                        Select Case BlnCls_ListFileOrFolder
                            Case True
                                ' ファイル取得.
                                Dim FI As System.IO.FileInfo = .Item(.Count - 1)
                                Str_FullName = FI.FullName
                            Case Else
                                ' フォルダー取得.
                                Dim FI As System.IO.DirectoryInfo = .Item(.Count - 1)
                                Str_FullName = FI.FullName
                        End Select
                        ' リストボックスに追加します.
                        If Me.InvokeRequired Then
                            Me.Invoke(New SetName_Invoke(AddressOf AddFileList), New Object() {Str_FullName} )
                        Else
                            Me.AddFileList(Str_FullName)
                        End If
                    End With
                Catch ex As Exception
                End Try
            End Sub
        #End Region

        #Region "ファイルまたはフォルダーリスト取得終了時に呼び出されるイベント関数."
            Private Sub GetFileListEnd_Callback(ByVal sender As Object, ByVal e As NSDFile.NSDFileFolderListEventArgs)
                Try
                    ' ボタンのテキストを設定.
                    If Me.InvokeRequired Then
                        Me.Invoke(New SetName_Invoke(AddressOf SetBtn_FileList), New Object() {"リストの取得"} )
                    Else
                        Me.SetBtn_FileList("リストの取得")
                    End If
                    MsgBox("検索が終了しました。")
                    BlnCls_GetFileFolder = False    
                Catch ex As Exception
                End Try
            End Sub
        #End Region

        #Region "ファイル、フォルダー取得用リストボックスに追加します."
            Public Sub AddFileList(ByVal StrVal_FileName As String)
                Try
                    Me.ListBox1.Items.Add(StrVal_FileName)
                    Me.Lbl_ListCount.Text = "取得件数：" & Me.ListBox1.Items.Count
                Catch ex As Exception
                End Try
            End Sub
        #End Region

        #Region "Sub SetBtn_FileList : リスト取得用ボタンのテキスト設定."
            Public Sub SetBtn_FileList(ByVal StrVal_Text As String)
                Try
                    Me.Btn_GetFile.Text = StrVal_Text
                Catch ex As Exception
                End Try
            End Sub
        #End Region

        #Region "Sub RB_List_File1_CheckedChanged : リスト取得種類の切り替え."
            Private Sub RB_List_File1_CheckedChanged( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles RB_List_File1.CheckedChanged
                Try
                    Select Case CType(sender, RadioButton).Checked
                        Case True
                            ' ファイル.
                            BlnCls_ListFileOrFolder = True
                        Case Else
                            ' フォルダー.
                            BlnCls_ListFileOrFolder = False
                    End Select
                    Me.Lbl_File_SearchPattern1.Enabled = BlnCls_ListFileOrFolder
                    Me.Lbl_File_SearchPattern2.Enabled = BlnCls_ListFileOrFolder
                    Me.Txt_SearchPattern.Enabled = BlnCls_ListFileOrFolder
                Catch ex As Exception
                End Try
            End Sub
        #End Region
    #End Region

    #Region "コピーします."
        #Region "Sub Btn_Copy_Click : コピー."
            Private Sub Btn_Copy_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Btn_Copy.Click
                Try
                    Select Case BlnCls_CopyFileFolder
                        Case False
                            If IsRunOk(RunKind.FileCopy) AndAlso IsRunOk(RunKind.FolderCopy) Then
                                ' コピーを行います.
                                Dim Str_Source As String = Me.Txt_Source.Text
                                Dim Str_Destination As String = Me.Txt_Destination.Text
                                Me.Btn_Copy.Text = "中止"

                                BlnCls_CopyFileFolder = True
                                If BlnCls_CopyFileOrFolder Then
                                    ' ファイルのコピー.
                                    If (Cls_CopyFile Is Nothing) Then
                                        Cls_CopyFile = New NSDFile.NSDCopyFile
                                    End If
                                    Cls_CopyFile.CopyFile(Str_Source, _
                                                          Str_Destination, _
                                                          True, _
                                                          True, _
                                                          Nothing, _
                                                          AddressOf EventVal_CopyFileEndCallback, _
                                                          Cls_CopyFileDispControl, _
                                                          Nothing)
                                Else
                                    ' フォルダーのコピー.

                                    ' フォルダー用クラスの割り当て確認.
                                    If (Cls_CopyFolder Is Nothing) Then
                                        Cls_CopyFolder = New NSDFile.NSDCopyFolder
                                    End If
                                    ' フォルダーをコピーします.
                                    Me.Btn_Copy.Text = "中止"
                                    Cls_CopyFolder.CopyFolder(Str_Source, _
                                                              Str_Destination, _
                                                              Me.Chk_Copy1.Checked, _
                                                              Nothing, _
                                                              Nothing, _
                                                              Nothing, _
                                                              Nothing, _
                                                              AddressOf EventVal_CopyFolderEnd, _
                                                              Cls_CopyFolderDispControl)
                                End If
                            End If
                        Case Else
                            ' コピーを中止します.
                            Me.Btn_Copy.Text = "コピー"
                            If BlnCls_CopyFileOrFolder Then
                                If Not (Cls_CopyFile Is Nothing) Then
                                    Cls_CopyFile.StopCopyFile = True
                                End If
                            Else
                                If Not (Cls_CopyFolder Is Nothing) Then
                                    Cls_CopyFolder.StopCopyFolder = True
                                End If
                            End If
                            BlnCls_CopyFileFolder = False
                    End Select
                Catch ex As Exception
                End Try
            End Sub
        #End Region

        #Region "Sub EventVal_CopyFileEndCallback : コピー終了時に呼び出されるイベント関数."
            Public Sub EventVal_CopyFileEndCallback(ByVal sender As Object, ByVal e As NSDFile.NSDCopyFile.NSDFileCopyEventArgs)
                Try
                    If Me.InvokeRequired Then
                        Me.Invoke(New SetName_Invoke(AddressOf SetBtn_CopyFile), New Object() {"コピー"} )
                    Else
                        Me.SetBtn_CopyFile("コピー")
                    End If
                    MsgBox(Cls_CopyFile.GetEndStyleMsg(e.EndStyle))
                    ' コントロールを初期化します.
                    Cls_CopyFile.SetControl_Init(Cls_CopyFileDispControl)
                    BlnCls_CopyFileFolder = False
                Catch ex As Exception
                Finally
                    Cls_CopyFile.Dispose()
                    Cls_CopyFile = Nothing
                End Try
            End Sub
        #End Region

        #Region "Sub EventVal_CopyFolderEnd : フォルダーコピー終了時に呼び出されるイベント関数."
            Private Sub EventVal_CopyFolderEnd(ByVal Sender As Object, ByVal e As NSDFile.NSDCopyFolder.NSDCopyFolderEventArgs)
                Try
                    If Me.InvokeRequired Then
                        Me.Invoke(New SetName_Invoke(AddressOf SetBtn_CopyFile), New Object() {"コピー"} )
                    Else
                        Me.SetBtn_CopyFile("コピー")
                    End If
                    MsgBox(Cls_CopyFolder.GetEndStyleMsg(E.EndStyle))
                    ' コントロールを初期化します.
                    Cls_CopyFolder.SetControl_Init(Cls_CopyFolderDispControl)
                    BlnCls_CopyFileFolder = False
                Catch ex As Exception
                Finally
                    If Not(Cls_CopyFolder Is Nothing) Then
                        Cls_CopyFolder.Dispose()
                        Cls_CopyFolder = Nothing
                    End If
                End Try
            End Sub

        #End Region

        #Region "Sub SetBtn_CopyFile : コピー用ボタンのテキスト設定."
            Public Sub SetBtn_CopyFile(ByVal StrVal_Text As String)
                Try
                    Me.Btn_Copy.Text = StrVal_Text
                Catch ex As Exception
                End Try
            End Sub
        #End Region

        #Region "Sub RB_Copy_Kind1_CheckedChanged : コピー種類の切り替え."
            Private Sub RB_Copy_Kind1_CheckedChanged( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles RB_Copy_Kind1.CheckedChanged
                Try
                    BlnCls_CopyFileOrFolder = CType(sender, RadioButton).Checked
                    Me.Chk_Copy1.Enabled = Not BlnCls_CopyFileOrFolder
                    Me.Panel2.Enabled = Not BlnCls_CopyFileOrFolder
                Catch ex As Exception
                End Try
            End Sub
        #End Region
    #End Region

    #Region "フォルダー削除."
        #Region "完全にフォルダーを削除."
            #Region "Sub Btn_Delete_Click : フォルダー削除."
                Private Sub Btn_Delete_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Btn_Delete.Click
                    Try
                        Select Case BlnCls_DeleteFolder
                            Case False
                                If IsRunOk(RunKind.FolderDelete) Then
                                    ' 削除を行います.
                                    If MsgBox("フォルダーを削除します。" & vbCrLf & "削除したフォルダーは元に戻すことはできません。" & vbCrLf & "削除を途中で中止しても、既に削除された物は復元できません。" & vbCrLf & vbCrLf & "削除します。よろしいですか？", MsgBoxStyle.YesNo) = MsgBoxResult.Yes Then
                                        If MsgBox("削除したフォルダーは復元できません。" & vbCrLf & "本当によろしいですか？", MsgBoxStyle.YesNo + MsgBoxStyle.DefaultButton2)  = MsgBoxResult.Yes Then
                                            BlnCls_DeleteFolder = True

                                            Me.Lbl_FolderDelete1_1.Text = 0
                                            Me.Lbl_FolderDelete2_1.Text = 0

                                            IntCls_DeleteFolder_FileCount = 0    ' 削除ファイル数.
                                            IntCls_DeleteFolder_FolderCount = 0  ' 削除フォルダー数.

                                            Me.Btn_Delete.Text = "中止"
                                            If (Cls_DeleteFolder Is Nothing) Then
                                                Cls_DeleteFolder = New NSDFile.NSDDeleteFolder
                                            End If

                                            Cls_DeleteFolder.DeleteFolder(Me.Txt_Delete.Text, _
                                                                          AddressOf EventVal_DeleteFolderOneFileCallback, _
                                                                          AddressOf EventVal_DeleteFolderOneFolderCallback, _
                                                                          AddressOf EventVal_DeleteFolderEndCallback)
                                        End If
                                    End If
                                End If
                            Case Else
                                ' 削除を中止します.
                                Me.Btn_Delete.Text = "フォルダー削除"
                                If Not (Cls_DeleteFolder Is Nothing) Then
                                    Cls_DeleteFolder.StopDeleteFolder = True
                                End If
                                BlnCls_DeleteFolder = False
                        End Select
                    Catch ex As Exception
                    End Try
                End Sub
            #End Region

            #Region "Sub EventVal_DeleteFolderOneFileCallback : 1ファイル削除時に呼び出されるイベント関数."
                Private Sub EventVal_DeleteFolderOneFileCallback( ByVal sender As Object, ByVal e As NSDFile.NSDDeleteFolder.NSDDeleteFolderEventArgs)
                    Try
                        ' 削除ファイル数をカウントします.
                        IntCls_DeleteFolder_FileCount += 1
                        Dim Str_FileCount As String = Format(IntCls_DeleteFolder_FileCount, "###,##0")
                        ' 削除ファイル数を表示します.
                        If Me.InvokeRequired Then
                            Me.Invoke(New SetName_Invoke(AddressOf SetLbl_DeleteFile), New Object() {Str_FileCount} )
                        Else
                            Me.SetLbl_DeleteFile(Str_FileCount)
                        End If
                    Catch ex As Exception
                    End Try
                End Sub
            #End Region

            #Region "Sub EventVal_DeleteFolderOneFolderCallback : 1フォルダー削除時に呼び出されるイベント関数."
                Private Sub EventVal_DeleteFolderOneFolderCallback( ByVal sender As Object, ByVal e As NSDFile.NSDDeleteFolder.NSDDeleteFolderEventArgs)
                    Try
                        ' 削除フォルダー数をカウントします.
                        IntCls_DeleteFolder_FolderCount += 1
                        Dim Str_FolderCount As String = Format(IntCls_DeleteFolder_FolderCount, "###,##0")
                        ' 削除フォルダー数を表示します.
                        If Me.InvokeRequired Then
                            Me.Invoke(New SetName_Invoke(AddressOf SetLbl_DeleteFolder), New Object() {Str_FolderCount} )
                        Else
                            Me.SetLbl_DeleteFolder(Str_FolderCount)
                        End If
                    Catch ex As Exception
                    End Try
                End Sub
            #End Region

            #Region "Sub EventVal_DeleteFolderEndCallback : フォルダー削除終了時に呼び出されるイベント関数."
                Private Sub EventVal_DeleteFolderEndCallback( ByVal sender As Object, ByVal e As NSDFile.NSDDeleteFolder.NSDDeleteFolderEventArgs)
                    Try
                        If Me.InvokeRequired Then
                            Me.Invoke(New SetName_Invoke(AddressOf SetBtn_DeleteFolder), New Object() {"フォルダー削除"} )
                        Else
                            Me.SetBtn_DeleteFolder("フォルダー削除")
                        End If
                        MsgBox(Cls_DeleteFolder.GetEndStyleMsg(e.EndStyle))
                        BlnCls_DeleteFolder = False
                    Catch ex As Exception
                    Finally
                        If Not (Cls_DeleteFolder Is Nothing) Then
                            Cls_DeleteFolder.Dispose()
                            Cls_DeleteFolder =  Nothing
                        End If
                    End Try
                End Sub
            #End Region

            #Region "Sub SetLbl_DeleteFile : 削除ファイル数のテキスト設定."
                Public Sub SetLbl_DeleteFile(ByVal StrVal_Text As String)
                    Try
                        Me.Lbl_FolderDelete1_1.Text = StrVal_Text
                    Catch ex As Exception
                    End Try
                End Sub
            #End Region

            #Region "Sub SetLbl_DeleteFolder : 削除フォルダー数のテキスト設定."
                Public Sub SetLbl_DeleteFolder(ByVal StrVal_Text As String)
                    Try
                        Me.Lbl_FolderDelete2_1.Text = StrVal_Text
                    Catch ex As Exception
                    End Try
                End Sub
            #End Region

            #Region "Sub SetBtn_DeleteFolder : フォルダー削除用ボタンのテキスト設定."
                Public Sub SetBtn_DeleteFolder(ByVal StrVal_Text As String)
                    Try
                        Me.Btn_Delete.Text = StrVal_Text
                    Catch ex As Exception
                    End Try
                End Sub
            #End Region
        #End Region

        #Region "Sub Btn_Remove_Click : ゴミ箱に移動."
            Private Sub Btn_Remove_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Btn_Remove.Click
                Try
                    If MsgBox("ゴミ箱に移動します。" & vbCrLf & "よろしいですか？", MsgBoxStyle.YesNo) = MsgBoxResult.Yes Then
                        If Cls_File.RemoveFolder(Me.Txt_Delete.Text) Then
                            MsgBox("ゴミ箱に移動しました。")
                        Else
                            MsgBox("ゴミ箱の移動に失敗しました。")
                        End If
                    End If
                Catch ex As Exception
                End Try
            End Sub
        #End Region
    #End Region

    #Region "フォルダーサイズ."
        #Region "Sub Btn_FolderSize_Click : フォルダーサイズを取得します."
            Private Sub Btn_FolderSize_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Btn_FolderSize.Click
                Try
                    Select Case BlnCls_FolderSize
                        Case False
                            If IsRunOk(RunKind.GetFolderSize) Then
                                ' フォルダーサイズの取得.
                                BlnCls_FolderSize = True
                                Me.Btn_FolderSize.Text = "中止"
                                If (Cls_FolderSize Is Nothing) Then
                                    Cls_FolderSize = New NSDFile.NSDFolderSize
                                End If
                                Cls_FolderSize.GetFolderSize(Me.Txt_FolderSize.Text, _
                                                             True, _
                                                             Nothing, _
                                                             Nothing, _
                                                             AddressOf Event_GetFolderSizeEndCallback, _
                                                             Cls_FolderSizeDispControl)
                            End If
                        Case Else
                            ' フォルダーサイズの取得を中止します.
                            Me.Btn_FolderSize.Text = "サイズ取得"
                            If Not (Cls_FolderSize Is Nothing) Then
                                Cls_FolderSize.StopGetFolderSize = True
                            End If
                            BlnCls_FolderSize = False
                    End Select
                Catch ex As Exception
                End Try
            End Sub
        #End Region

        #Region "Sub Event_GetFolderSizeEndCallback : フォルダサイズ取得時に呼び出されるイベント関数."
            Public Sub Event_GetFolderSizeEndCallback(ByVal sender As Object, ByVal e As NSDFile.NSDFolderSize.NSDFolderSizeEventArgs)
                Try
                    If Me.InvokeRequired Then
                        Me.Invoke(New SetName_Invoke(AddressOf SetBtn_FolderSize), New Object() {"サイズ取得"} )
                    Else
                        Me.SetBtn_FolderSize("サイズ取得")
                    End If
                    MsgBox(Cls_FolderSize.GetEndStyleMsg(e.EndStyle))
                Catch ex As Exception
                Finally
                    If Not (Cls_FolderSize Is Nothing) Then
                        Cls_FolderSize.Dispose()
                        Cls_FolderSize = Nothing
                    End If
                End Try
            End Sub
        #End Region

        #Region "Sub SetBtn_FolderSize : フォルダーサイズ取得ボタンのテキスト設定."
            Public Sub SetBtn_FolderSize(ByVal StrVal_Text As String)
                Try
                    Me.Btn_FolderSize.Text = StrVal_Text
                Catch ex As Exception
                End Try
            End Sub
        #End Region
    #End Region

    #Region "現在動作中の確認."
        Enum RunKind As Integer
            NotRun = 0          ' 動作なし.
            GetFile = 1         ' ファイルリスト.
            GetFolder = 2       ' フォルダーリスト.
            FileCopy = 3        ' ファイルコピー.
            FolderCopy = 4      ' フォルダーコピー.
            FolderDelete = 5    ' フォルダー削除.
            GetFolderSize = 6     ' フォルダサイズ.
        End Enum
        Private Function IsRunOk(ByVal IntVal_RunKind As RunKind) As Boolean
            Dim Bln_Ret As Boolean = True  ' 戻り値.
            Dim Str_Msg As String = Nothing
            Try
                If IntVal_RunKind <> RunKind.NotRun Then
                    If IntVal_RunKind <> RunKind.GetFile Then
                        If Cls_File.IsGetFileRunning = NSDFile.NSD_File_Run_Style.Running Then
                            Str_Msg = "現在、ファイル検索中です。" & vbCrLf & "ファイル検索終了後に実行してください。"
                            Bln_Ret = False
                        End If
                    End If
                    If IntVal_RunKind <> RunKind.GetFolder Then
                        If Cls_File.IsGetFolderRunning = NSDFile.NSD_File_Run_Style.Running Then
                            MsgBox("現在、フォルダー検索中です。" & vbCrLf & "フォルダー検索終了後に実行してください。")
                            Bln_Ret = False
                        End If
                    End If
                    If IntVal_RunKind <> RunKind.FileCopy Then
                        If Not (Cls_CopyFile Is Nothing) Then
                            If Cls_CopyFile.IsCopyFileRunning = NSDFile.NSD_File_Run_Style.Running Then
                                Str_Msg = "現在ファイルコピー中です。" & vbCrLf & "ファイルコピー終了後に実行してください。"
                                Bln_Ret = False
                            End If
                        End If
                    End If
                    If IntVal_RunKind <> RunKind.FolderCopy Then
                        If Not (Cls_CopyFolder Is Nothing) Then
                            If Cls_CopyFolder.IsCopyFolderRunning = NSDFile.NSD_File_Run_Style.Running Then
                                Str_Msg = "現在フォルダーコピー中です。" & vbCrLf & "フォルダーコピー終了後に実行してください。"
                                Bln_Ret = False
                            End If
                        End If
                    End If
                    If IntVal_RunKind <> RunKind.FolderDelete Then
                        If Not (Cls_DeleteFolder Is Nothing) Then
                            If Cls_DeleteFolder.IsDeleteFolderRunning = NSDFile.NSD_File_Run_Style.Running Then
                                Str_Msg = "現在フォルダー削除中です。" & vbCrLf & "フォルダー削除終了後に実行してください。"
                                Bln_Ret = False
                            End If
                        End If
                    End If
                    If IntVal_RunKind <> RunKind.GetFolderSize Then
                        If Not (Cls_FolderSize Is Nothing) Then
                            If Cls_FolderSize.IsGetFolderSizeRunning = NSDFile.NSD_File_Run_Style.Running Then
                                Str_Msg = "現在フォルダーサイズ取得中です。" & vbCrLf & "フォルダーサイズ取得終了後に実行してください。"
                                Bln_Ret = False
                            End If
                        End If
                    End If
                End If
                If Not Bln_Ret Then
                    MsgBox(Str_Msg)
                End If
            Catch ex As Exception
            End Try
            ' 結果を戻します.
            Return Bln_Ret
        End Function
    #End Region

    #Region "パス"
        #Region "Sub Btn_Path_OriginalName_Click : オリジナルパス名に変更."
            Private Sub Btn_Path_OriginalName_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Btn_Path_OriginalName.Click
                Try
                    Me.Txt_Path.Text = Cls_File.ChangeOriginalName(Me.Txt_Path.Text)
                Catch ex As Exception
                End Try
            End Sub
        #End Region

        #Region "Sub RB_Path1_CheckedChanged : ファイル、フォルダーの切り替え."
            Private Sub RB_Path1_CheckedChanged( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles RB_Path1.CheckedChanged
                Try
                    BlnCls_PathFileOrFolder = Me.RB_Path1.Checked
                Catch ex As Exception
                End Try
            End Sub
        #End Region

        #Region "Sub Btn_Path_Low_Click : パス名を小文字に変換."
            Private Sub Btn_Path_Low_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Btn_Path_Low.Click
                Try
                    Me.Txt_Path.Text = Me.Txt_Path.Text.ToLower
                Catch ex As Exception
                End Try
            End Sub
        #End Region

        #Region "Sub Btn_Path_Up_Click : パス名を大文字に変換."
            Private Sub Btn_Path_Up_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Btn_Path_Up.Click
                Try
                    Me.Txt_Path.Text = Me.Txt_Path.Text.ToUpper
                Catch ex As Exception
                End Try
            End Sub
        #End Region
    #End Region

    #Region "空き容量."
        #Region "Sub Btn_FreeSpace_Click : ドライブの空き容量."
            Private Sub Btn_FreeSpace_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Btn_FreeSpace.Click
                Try
                    Dim Lng_FreeSpace As Long = Cls_File.GetDriveFreeSpace(Me.Txt_FreeSpace.Text)
                    If Lng_FreeSpace = -1 Then
                        MsgBox("ドライブ空き容量の取得に失敗しました。" & vbCrLf & "パス名に空き容量を取得するドライブ名を入力してください。")
                    Else
                        MsgBox("空き容量：" & Format(Lng_FreeSpace, "###,##0"))
                    End If
                Catch ex As Exception
                End Try
            End Sub
        #End Region
    #End Region

    #Region "ファイル作成"
        #Region "Sub Btn_AllocateFile_Click : 指定サイズのファイルを作成."
            Private Sub Btn_AllocateFile_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Btn_AllocateFile.Click
                Try
                    Dim Str_Msg As String = ""
                    If Cls_File.IsFolder(Me.Txt_Create.Text) Then
                        MsgBox("フォルダーが存在します。" & vbCrLf & "作成するファイル名をフルパス名で入力してください。")
                    Else
                        If Cls_File.IsFile(Me.Txt_Create.Text) Then
                            MsgBox("既にファイルが存在します。")
                        Else
                            Str_Msg = "ファイルを作成します。" & vbCrLf & "よろしいですか？"
                            If MsgBox(Str_Msg, MsgBoxStyle.YesNo+MsgBoxStyle.DefaultButton2) = MsgBoxResult.Yes Then
                                If Cls_File.AllocateFile(Me.Txt_Create.Text, Me.NumericUpDown1.Value) Then
                                    MsgBox("ファイルを作成しました。")
                                Else
                                    MsgBox("ファイルの作成に失敗しました。")
                                End If
                            End If
                        End If
                    End If
                Catch ex As Exception
                End Try
            End Sub
        #End Region
    #End Region

    #Region "ファイル、フォルダの確認."
        #Region "Sub Btn_Other_File_Click : ファイルの確認."
            Private Sub Btn_Other_File_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Btn_Other_File.Click
                Try
                    If Cls_File.IsFile(Me.Txt_Other_Path.Text) Then
                        MsgBox("ファイルが存在します。")
                    Else
                        MsgBox("ファイルでありません。")
                    End If
                Catch ex As Exception
                End Try
            End Sub
        #End Region

        #Region "Sub Btn_Other_Folder_Click : フォルダーの確認."
            Private Sub Btn_Other_Folder_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Btn_Other_Folder.Click
                Try
                    If Cls_File.IsFolder(Me.Txt_Other_Path.Text) Then
                        MsgBox("フォルダーが存在します.")
                    Else
                        MsgBox("フォルダーでありません.")
                    End If
                Catch ex As Exception
                End Try
            End Sub
        #End Region

        #Region "Sub RB_Other_1_CheckedChanged : ファイル、フォルダーの切り替え."
            Private Sub RB_Other_1_CheckedChanged( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles RB_Other_1.CheckedChanged
                Try
                    BlnCls_OtherFileOrFolder = Me.RB_Other_1.Checked
                    GroupBox5.Enabled = BlnCls_OtherFileOrFolder
                Catch ex As Exception
                End Try
            End Sub
        #End Region
    #End Region

    #Region "参照."
        Private Sub SetReferenceButton(ByVal BlnVal_Set As Boolean)
            Try
                If BlnVal_Set Then
                    Me.Btn_Reference = New System.Windows.Forms.Button(11) {}
                    ' リスト取得の参照.
                    Me.Btn_Folder.Tag = Me.TextBox1
                    Me.Btn_Reference(0) = Me.Btn_Folder
                    ' コピー元の参照.
                    Me.Btn_Source1.Tag = Me.Txt_Source
                    Me.Btn_Reference(1) = Me.Btn_Source1
                    ' コピー先の参照.
                    Me.Btn_Destination1.Tag = Me.Txt_Destination
                    Me.Btn_Reference(2) = Me.Btn_Destination1
                    ' 削除フォルダーの参照.
                    Me.Btn_RDelete.Tag = Me.Txt_Delete
                    Me.Btn_Reference(3) = Me.Btn_RDelete
                    ' フォルダーサイズ.
                    Me.Btn_RFolderSize.Tag = Me.Txt_FolderSize
                    Me.Btn_Reference(4) = Me.Btn_RFolderSize
                    ' パス.
                    Me.Btn_RPath.Tag = Me.Txt_Path
                    Me.Btn_Reference(5) = Me.Btn_RPath
                    ' 空き容量.
                    Me.Btn_RFreeSpace.Tag = Me.Txt_FreeSpace
                    Me.Btn_Reference(6) = Me.Btn_RFreeSpace
                    ' ファイル作成.
                    Me.Btn_RCreate.Tag = Me.Txt_Create
                    Me.Btn_Reference(7) = Me.Btn_RCreate
                    ' その他.
                    Me.Btn_ROther.Tag = Me.Txt_Other_Path
                    Me.Btn_Reference(8) = Me.Btn_ROther
                    ' ファイル確認.
                    Me.Btn_EqualFile1.Tag = Me.Txt_EqualFile1
                    Me.Btn_Reference(9) = Me.Btn_EqualFile1
                    Me.Btn_EqualFile2.Tag = Me.Txt_EqualFile2
                    Me.Btn_Reference(10) = Me.Btn_EqualFile2
                    ' テキストファイル確認.
                    Me.Btn_TextFile.Tag = Me.Txt_TextFile
                    Me.Btn_Reference(11) = Me.Btn_TextFile

                    For Each OneButton As Button In Btn_Reference
                        AddHandler OneButton.Click, AddressOf Btn_Reference_Click
                    Next
                Else
                    For Each OneButton As Button In Btn_Reference
                        RemoveHandler OneButton.Click, AddressOf Btn_Reference_Click
                    Next
                End If
            Catch ex As Exception
            End Try
        End Sub

        #Region "Sub Btn_Reference_Click : 参照ボタンのクリック."
            Private Sub Btn_Reference_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs)
                Try
                    Dim Bln_FileOrFolder As Boolean = False
                    Dim Bln_ReadOnly As Boolean = False
                    Select Case CType(sender, Button).Name
                        Case "Btn_Source1"
                            Bln_FileOrFolder = BlnCls_CopyFileOrFolder
                            Bln_ReadOnly = True
                        Case "Btn_Destination1"
                            Bln_FileOrFolder = BlnCls_CopyFileOrFolder
                        Case "Btn_RPath"
                            Bln_FileOrFolder = BlnCls_PathFileOrFolder
                        Case "Btn_RCreate", "Btn_EqualFile1", "Btn_EqualFile2", "Btn_TextFile"
                            Bln_FileOrFolder = True
                        Case "Btn_ROther"
                            Bln_FileOrFolder = BlnCls_OtherFileOrFolder
                        Case Else
                    End Select
                    If Bln_FileOrFolder Then
                        ' ファイル.
                        Using FO As New System.Windows.Forms.OpenFileDialog
                            With FO
                                .ReadOnlyChecked = Bln_FileOrFolder
                                .Multiselect = False
                                .CheckFileExists = False
                                .FileName = Ctype(CType(sender, Button).Tag, TextBox).Text
                                If .ShowDialog() = Windows.Forms.DialogResult.OK Then
                                    Ctype(CType(sender, Button).Tag, TextBox).Text = .FileName
                                End If
                            End With
                        End Using
                    Else
                        ' フォルダー.
                        Using FBD As New System.Windows.Forms.FolderBrowserDialog
                            FBD.SelectedPath = Ctype(CType(sender, Button).Tag, TextBox).Text
                            If FBD.ShowDialog() = Windows.Forms.DialogResult.OK Then
                                Ctype(CType(sender, Button).Tag, TextBox).Text = FBD.SelectedPath
                            End If
                        End Using
                    End If
                Catch ex As Exception
                End Try
            End Sub
        #End Region
    #End Region

    #Region "ファイル確認."
        #Region "Sub Btn_EqualCheck_Click : ファイル内容が同じかを確認."
            Private Sub Btn_EqualCheck_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Btn_EqualCheck.Click
                Try
                    Do
                        Dim Str_FileName1 As String = Me.Txt_EqualFile1.Text
                        Dim Str_FileName2 As String = Me.Txt_EqualFile2.Text

                        If String.IsNullOrEmpty(Str_FileName1) Then
                            MsgBox("ファイル1にファイルのフルパス名を入力してください。")
                            Exit Do
                        End If
                        If String.IsNullOrEmpty(Str_FileName2) Then
                            MsgBox("ファイル2にファイルのフルパス名を入力してください。")
                            Exit Do
                        End If

                        If Str_FileName1.ToUpper = Str_FileName2.ToUpper Then
                            MsgBox("同じファイルが入力されています。" & vbCrLf & "異なるフルパス名を入力してください。")
                        Else
                            If Cls_File.IsEqualFile(Str_FileName1, Str_FileName2) Then
                                MsgBox("同じ内容のファイルです。")
                            Else
                                MsgBox("ファイル内容に相違があります。")
                            End If
                        End If

                    Loop While (0)
                Catch ex As Exception

                End Try
            End Sub
        #End Region
    #End Region

    #Region "テキストファイル確認."
        #Region "Sub Btn_TotalLine_Click : 全行数の表示."
            Private Sub Btn_TotalLine_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Btn_TotalLine.Click
                Try
                    
                    Dim Str_FileName As String = Me.Txt_TextFile.Text   ' ファイル名.
                    Dim Lng_Count As Long = 0                           ' 行数.
                    Dim Str_NewLineCode As String = GetNewLineCode()    ' 改行コード.

                    ' 全行数を取得します.
                    Lng_Count = Cls_TextFile.GetTotalLineCount(Str_FileName, CType(Cmb_TextFile.SelectedItem, ClsEncodeInfo).Encode, Str_NewLineCode)
                    MsgBox("全行数 =" & Lng_Count.ToString())
                Catch ex As Exception

                End Try
            End Sub
        #End Region

        #Region "Sub Btn_TextFile_Delete_Click : 指定行数を削除."
            Private Sub Btn_TextFile_Delete_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Btn_TextFile_Delete.Click
                Try
                    Dim Str_FileName As String = Me.Txt_TextFile.Text       ' ファイル名.
                    Dim Lng_DeleteCount As Long = Me.NUD_TextFile.Value     ' 削除する行数.
                    Dim Lng_RetDeleteCount As Long = 0                      ' 削除した行数.
                    Dim Str_NewLineCode As String = GetNewLineCode()        ' 改行コード.
                    Dim Str_Msg As String = Nothing                         ' メッセージ.
                    Dim Str_SE_Msg As String = Nothing                      ' 先頭または末尾.

                    Select Case Me.RB_Delete_S.Checked
                        Case True:  Str_SE_Msg = "先頭"
                        Case False: Str_SE_Msg = "末尾"
                    End Select

                    Str_Msg = "ファイル名" & vbCrLf & " " & Str_FileName & vbCrLf & "の" & Str_SE_Msg & "から " & Lng_DeleteCount.ToString() & "行を削除します。" & vbCrLf & vbCrLf & "よろしいですか？"
                    If MsgBox(Str_Msg, vbYesNo) = vbYes Then
                        Select Case Me.RB_Delete_S.Checked
                            Case True: Lng_RetDeleteCount = Cls_TextFile.DeleteStartLineCount(Str_FileName, Lng_DeleteCount, CType(Cmb_TextFile.SelectedItem, ClsEncodeInfo).Encode, Str_NewLineCode)
                            Case False:Lng_RetDeleteCount = Cls_TextFile.DeleteEndLineCount(Str_FileName, Lng_DeleteCount, CType(Cmb_TextFile.SelectedItem, ClsEncodeInfo).Encode, Str_NewLineCode)
                        End Select
                        If Lng_RetDeleteCount <> 0 Then
                            MsgBox("ファイルの" & Str_SE_Msg & "から " & Lng_RetDeleteCount.ToString & "行を削除しました。")
                        Else
                            MsgBox("ファイルの" & Str_SE_Msg & "から " & Lng_DeleteCount.ToString & "行の削除に失敗しました。")
                        End If
                    End If

                Catch ex As Exception
                End Try
            End Sub
        #End Region

        #Region "Sub Btn_AppendOneLine_Click : 1行追加します."
            Private Sub Btn_AppendOneLine_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Btn_AppendOneLine.Click
                Try
                    Dim Str_FileName As String = Me.Txt_TextFile.Text       ' ファイル名.
                    Dim Str_NewLineCode As String = GetNewLineCode()        ' 改行コード.
                    Dim Str_Msg As String = Nothing                         ' メッセージ.
                    Dim Str_WriteText As String = Me.Txt_AppendOneLine.Text ' 追加する文字列.
                    Dim Str_SE_Msg As String = Nothing                      ' 最後または先頭.

                    Select Case Me.RB_Append_E.Checked
                        Case True:  Str_SE_Msg = "最後"
                        Case False: Str_SE_Msg = "先頭"
                    End Select

                    Do
                        If String.IsNullOrEmpty(Str_WriteText) Then
                            MsgBox("追加する文字列が入力されていません。")
                            Exit Do
                        End If
                        Str_Msg = "ファイル名" & vbCrLf & " " & Str_FileName & vbCrLf & "の" & Str_SE_Msg & "に追加します。" & vbCrLf & vbCrLf & "よろしいですか？"
                        If MsgBox(Str_Msg, vbYesNo) = vbYes Then
                            Dim Bln_Ret As Boolean = False  ' 戻り値.
                            Select Case Me.RB_Append_E.Checked
                                Case True:  Bln_Ret = Cls_TextFile.AppendOneLine(Str_FileName, Str_WriteText, CType(Cmb_TextFile.SelectedItem, ClsEncodeInfo).Encode, Str_NewLineCode)
                                Case False: Bln_Ret = Cls_TextFile.AppendStartOneLine(Str_FileName, Str_WriteText, CType(Cmb_TextFile.SelectedItem, ClsEncodeInfo).Encode, Str_NewLineCode, NSDFile.NSD_BOM_Style.CheckAndNewSet_BOM)
                            End Select

                            If Bln_Ret Then
                                MsgBox("1行追加しました。")
                            Else
                                MsgBox("追加に失敗しました。")
                            End If
                        End If
                    Loop While (0)
                Catch ex As Exception
                End Try
            End Sub
        #End Region

        #Region "Sub Btn_AppendNLine_Click : n行追加します."
            Private Sub Btn_AppendNLine_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles Btn_AppendNLine.Click
                Try
                    Dim Str_FileName As String = Me.Txt_TextFile.Text       ' ファイル名.
                    Dim Str_NewLineCode As String = GetNewLineCode()        ' 改行コード.
                    Dim Str_Msg As String = Nothing                         ' メッセージ.
                    Dim Str_WriteText As String = Me.Txt_AppendNLine.Text   ' 追加する文字列.
                    Dim Lng_WriteLine As Long = 0
                    Dim Str_SE_Msg As String = Nothing                      ' 最後または先頭.

                    Select Case Me.RB_Append_E.Checked
                        Case True:  Str_SE_Msg = "最後"
                        Case False: Str_SE_Msg = "先頭"
                    End Select

                    Do
                        If String.IsNullOrEmpty(Str_WriteText) Then
                            MsgBox("追加する文字列が入力されていません。")
                            Exit Do
                        End If
                        Str_Msg = "ファイル名" & vbCrLf & " " & Str_FileName & vbCrLf & "の" & Str_SE_Msg & "に追加します。" & vbCrLf & vbCrLf & "よろしいですか？"
                        If MsgBox(Str_Msg, vbYesNo) = vbYes Then
                            Select Case Me.RB_Append_E.Checked
                                Case True:  Lng_WriteLine = Cls_TextFile.AppendNLine(Str_FileName, Str_WriteText, CType(Cmb_TextFile.SelectedItem, ClsEncodeInfo).Encode, Str_NewLineCode)
                                Case False: Lng_WriteLine = Cls_TextFile.AppendStartNLine(Str_FileName, Str_WriteText, CType(Cmb_TextFile.SelectedItem, ClsEncodeInfo).Encode, Str_NewLineCode)
                            End Select
                            If Lng_WriteLine <> 0 Then
                                MsgBox(Lng_WriteLine.ToString() & "行追加しました。")
                            Else
                                MsgBox("追加に失敗しました。")
                            End If
                        End If
                    Loop While (0)
                Catch ex As Exception
                End Try
            End Sub
        #End Region

        #Region "Function GetNewLineCode : 改行コードを取得します."
            Private Function GetNewLineCode() As String
                Dim Str_Ret As String = ControlChars.CrLf     ' 戻り値.
                Try
                    Select Case Me.Cmb_CrLf.SelectedIndex
                        Case 0: Str_Ret = ControlChars.CrLf
                        Case 1: Str_Ret = ControlChars.Lf
                        Case 2: Str_Ret = ControlChars.Cr
                    End Select
                Catch ex As Exception
                End Try
                ' 結果を戻します.
                Return Str_Ret
            End Function
        #End Region
    #End Region

End Class
